{% extends "plantilla.html"%}
{% block contenido%}
{% load static %}

<div class="intro-section single-cover" id="home-section">

      <div class="slide-1" style="background-image: url('{{ imagen_url }}');" data-stellar-background-ratio="0.5">
        <div class="container">
          <div class="row align-items-center">
            <div class="col-12">
              <div class="row justify-content-center align-items-center text-center">
                <div class="col-lg-6">
                  <h1 data-aos="fade-up" data-aos-delay="0">Editar Asignatura</h1>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <div class="site-section center">
      <div class="container ">
       <div class="row ">
           <div class="col-sm-12 col-xl-12">
               <div class="bg-secondary rounded h-100 p-4">
                 <form class="" method="post" action="{% url 'actualizarAsignatura' %}"
                 enctype="multipart/form-data" id="frm_asignatura">
                     {% csrf_token %}
                     <div class="mb-3">
                       <select class="form-control selectpicker" data-live-search="true"
                       name="curso" id="curso"  aria-label="Floating label select example">
                       <option value="" disabled selected>-- Seleccione el curso --</option>
                       {% for curso in cursos %}
                           <option value="{{ curso.idCursodcp }}">{{ curso.nivelCursodcp }}</option>
                       {% endfor %}
                   </select>

                       <script type="text/javascript">

                               document.getElementById("curso").value = "{{ asignatura.curso.idCursodcp  }}"
                       </script>
                       <input class="form-control"type="hidden" name="id"  value="{{asignatura.idAsignaturadcp}}">
                     </div>
                       <label for="nombreAsignatura">Nombre de la Asignatura:</label>
                       <input class="form-control"type="text" id="nombre" name="nombre" required value="{{asignatura.nombreAsignaturadcp}}">
                       <br>

                       <label for="creditosAsignatura">Créditos de la Asignatura:</label>
                       <input class="form-control"type="number" id="creditos" name="creditos" required value="{{asignatura.creditosAsignaturadcp}}">
                       <br>

                       <label for="fechaInicio">Fecha de Inicio:</label>
                       <input class="form-control"type="date" id="fechaInicio" name="fechaInicio" required value="{{asignatura.fecha_inicioAsignaturadcp|date:'Y-m-d'}}">
                       <br>

                       <label for="fechaFinal">Fecha de Finalización:</label>
                       <input class="form-control"type="date" id="fechaFinal" name="fechaFinal" required value="{{asignatura.fecha_finalAsignaturadcp|date:'Y-m-d'}}">
                       <br>

                       <label for="profesor">Profesor:</label>
                       <input class="form-control"type="text" id="profesor" name="profesor" required value="{{asignatura.profesorAsignaturadcp}}">
                       <br>

                       <label for="silabo">Silabo (opcional):</label>
                       <input class="form-control"type="file" id="silabo" name="silabo">
                       <br>
                       <script>
                           // Javascript para actualizar la imagen al cargar la página
                           document.addEventListener('DOMContentLoaded', function () {
                               var imgSrc = "{{ asignatura.silaboAsignaturadcp.url }}";
                               var imagenPreview = document.getElementById('imagen-preview');
                               // Verificar si la imagen existe y es válida
                               if (imgSrc) {
                                   imagenPreview.src = imgSrc;
                               }
                           });
                       </script>


                       <label for="semestre">Semestre (opcional):</label>
                       <input class="form-control"type="text" id="semestre" name="semestre" value="{{asignatura.semestreAsignaturadcp}}">
                       <br>

                       <label for="descripcion">Descripción (opcional):</label>
                       <textarea class="form-control"id="descripcion" name="descripcion">{{asignatura.descripcionAsignaturadcp}}</textarea>
                       <br>

                       <input class="btn btn-warning" type="submit" value="Actualizar curso">
                     </form>

               </div>
               </div>
           </div>
          </div>


          </div>
          <!-- Ahora puedes agregar tu script de validación -->
          <script>
            $.validator.addMethod("nombreApellido", function(value, element) {
                return this.optional(element) || /^[a-zA-ZáéíóúüñÁÉÍÓÚÜÑ]+\s[a-zA-ZáéíóúüñÁÉÍÓÚÜÑ]+$/.test(value);
            }, "Por favor, introduce un nombre y un apellido con un espacio en el medio.");
            $.validator.addMethod("nomAsignatura", function(value, element) {
              return this.optional(element) || /^[a-zA-ZáéíóúüñÁÉÍÓÚÜÑ\s]+$/.test(value);
            }, "Por favor, introdusca solo letras en asignatura.");

            // Inicializa el formulario para validación
            $("#frm_asignatura").validate({
            rules: {
              curso: {
                required: true
              },
              nombre: {
                required: true,
                nomAsignatura:true
              },
              creditos: {
                required: true,
                digits: true,
                range: [1, 3]
              },
              fechaInicio: {
                required: true,
                date: true
              },
              fechaFinal: {
                required: true,
                date: true,
                greaterThan: "#fechaInicio" // Custom rule for date comparison
              },
              profesor: {
                required: true,
                // lettersonly: true,
                nombreApellido:true
              },
              silabo: {
                extension: "pdf|doc|docx"
              },
              semestre: {
                required:true,
                lettersonly: true,
                noSpace: true
              },
              descripcion: {
                required: true
              }
            },
            messages: {
              curso: "Por favor, seleccione un curso",
              nombre: "Por favor, introduzca el nombre de la asignatura",
              creditos: {
                required: "Por favor, introduzca el número de créditos",
                digits: "Por favor, introduzca solo números enteros",
                range: "Por favor, ingrese un número entre 1 y 3"
              },
              fechaInicio: {
                required: "Por favor, seleccione la fecha de inicio",
                date: "Por favor, ingrese una fecha válida"
              },
              fechaFinal: {
                required: "Por favor, seleccione la fecha de finalización",
                date: "Por favor, ingrese una fecha válida",
                greaterThan: "La fecha de finalización debe ser posterior a la fecha de inicio"
              },
              profesor: {
                required: "Por favor, introduzca el nombre del profesor",
                lettersonly: "Por favor, ingrese solo letras en el nombre del profesor"
              },
              silabo: {
                extension: "Por favor, seleccione un archivo con una extensión válida (pdf, doc, docx)"
              },
              semestre: {
                required: "Por favor, ingrese un semestre",
                lettersonly: "Por favor, ingrese solo letras en el semestre",
                noSpace: "No se permiten espacios en el semestre"
              },
              descripcion: "Por favor, ingrese una descripción"
            },
            // errorElement: "span",

            submitHandler: function (form) {
              form.submit();
            },
            // errorPlacement: function (error, element) {
            //   // Ajusta la colocación del mensaje de error
            //   error.addClass("invalid-feedback");
            //   element.closest(".mb-3").append(error);
            // },
            highlight: function (element, errorClass, validClass) {
              // Añade clases de Bootstrap para resaltar errores
              $(element).addClass("is-invalid").removeClass("is-valid");
            },
            unhighlight: function (element, errorClass, validClass) {
              // Añade clases de Bootstrap cuando no hay errores
              $(element).removeClass("is-invalid").addClass("is-valid");
            },
            });

            // Custom validation rule for date comparison
            $.validator.addMethod("greaterThan", function (value, element, param) {
            var startDate = $(param).val();
            return new Date(value) > new Date(startDate);
            }, "La fecha de finalización debe ser posterior a la fecha de inicio");

            // Custom validation rule for no spaces
            $.validator.addMethod("noSpace", function (value, element) {
            return value.indexOf(" ") === -1;
            }, "No se permiten espacios");

          </script>

{% endblock %}
